{
 "cells": [
  {
   "cell_type": "code",
   "execution_count": 1,
   "metadata": {
    "collapsed": false
   },
   "outputs": [],
   "source": [
    "import numpy as np\n",
    "import matplotlib.pyplot as plt\n",
    "%matplotlib notebook\n",
    "plt.style.use('ggplot')\n",
    "import random\n",
    "from random import randint\n",
    "import math"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# System Parameters"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": [
    "food_amount = 100\n",
    "pacman_amount = 1\n",
    "board_size = 100\n",
    "default_health = 5\n",
    "pacmen = []\n",
    "food = []\n",
    "crot = 1\n",
    "cloc =.2\n",
    "cbite = 1\n",
    "turn_loss = 1\n",
    "phi_prec = (80/255.)\n",
    "alpha_prec = 10/255.\n",
    "delta_prec = 10/255.\n",
    "pacman_radius = 1\n",
    "food_health = 5"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 3,
   "metadata": {
    "collapsed": false
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "[{pacman, x:86, y:89, phi:181}, {pacman, x:67, y:66, phi:55}]\n"
     ]
    }
   ],
   "source": [
    "class pacman:\n",
    "    def __init__(self):\n",
    "        #change dynamically\n",
    "        self.x = randint(0,board_size)\n",
    "        self.y = randint(0,board_size)\n",
    "        self.theta = randint(0,359)\n",
    "        self.health = default_health\n",
    "        #dna\n",
    "        self.phi = randint(0,255)\n",
    "        self.alpha = randint(0,255)\n",
    "        self.delta = randint(0,255)\n",
    "        \n",
    "        self.phi_val = self.phi*phi_prec\n",
    "        self.alpha_val = self.alpha*alpha_prec\n",
    "        self.delta_val = self.delta*delta_prec\n",
    "        #self.f = closest food\n",
    "        #self.dist = closest food distance\n",
    "    def __bool__(self):\n",
    "        return True\n",
    "    \n",
    "    def __repr__(self):\n",
    "        return \"{pacman, x:\"+str(self.x)+\", y:\"+str(self.y)+\", phi:\"+str(self.phi)+\"}\"\n",
    "    \n",
    "    def find_dist(self,f):\n",
    "        return np.sqrt((self.x-f.x)**2 + (self.y-f.y)**2)\n",
    "    \n",
    "    def find_angle(self,f):\n",
    "        dx = f.x - self.x\n",
    "        dy = f.y - self.y\n",
    "        theta1 = 360. - self.theta - math.degrees(math.atan((dx/dy)))\n",
    "        theta2 = 360. - self.theta - theta1\n",
    "        print(theta1)\n",
    "        if(theta1 < theta2):\n",
    "            return theta1\n",
    "        return theta2\n",
    "    \n",
    "    def check_angle(self,f):#check if the food is in the range\n",
    "        left_bound = self.theta - (self.phi_val/2)\n",
    "        right_bound = self.theta + (self.phi_val/2)\n",
    "        f_angle = self.find_angle(f)\n",
    "        if(left_bound > f_angle and right_bound < f_angle):\n",
    "            return True\n",
    "        if(left_bound > f_angle + 360. and right_bound < f_angle + 360.):\n",
    "            return True\n",
    "        return False\n",
    "        \n",
    "    def find_food(self):\n",
    "        global food\n",
    "        closest = False\n",
    "        closest_dist = False\n",
    "        for i in food:\n",
    "            dist = self.find_dist(i)\n",
    "            if((dist < closest_dist or not closest_dist) and (self.check_angle(i)) or True):\n",
    "                closest = i\n",
    "                closest_dist = dist\n",
    "            self.f = closest\n",
    "            self.dist = closest_dist\n",
    "        if(closest != False):\n",
    "            return True\n",
    "        return False\n",
    "        \n",
    "    def rotate_to_food(self):\n",
    "        #cost of rotate = crot*theta*health\n",
    "        #no cost to rotation\n",
    "        new_theta = self.find_angle(self.f)\n",
    "        error = random.uniform(self.alpha_val/-2., self.alpha_val/2.)\n",
    "        self.theta = new_theta + error\n",
    "        \n",
    "    def get_food(self):\n",
    "        self.rotate_to_food()\n",
    "        error = random.uniform(self.delta_val/-2., self.delta_val/2.)\n",
    "        new_dist = self.dist + error\n",
    "        angle = self.find_angle(self.f)\n",
    "        self.x += new_dist*np.cos(angle)\n",
    "        self.x = 400\n",
    "        self.y += new_dist*np.sin(angle)\n",
    "        cost = cloc*new_dist\n",
    "        self.health -= cost\n",
    "        #cost of rotate\n",
    "    \n",
    "    def bite(self):\n",
    "        to_food = self.find_dist(self.f)\n",
    "        self.health -= cbite\n",
    "        if(to_food < pacman_radius):#means the bite was sucessful\n",
    "            self.health += food_health\n",
    "            food.remove(self.f)\n",
    "            \n",
    "    \n",
    "    def random_rotate(self):\n",
    "        self.theta = randint(0,359)\n",
    "        #self.health += randint(-2,1)\n",
    "    \n",
    "    def step(self):\n",
    "        self.health -= turn_loss\n",
    "        if(self.find_food()):\n",
    "            self.get_food()\n",
    "            self.bite()\n",
    "        self.random_rotate()\n",
    "    \n",
    "    \n",
    "    def get_genes(self):\n",
    "        return[self.phi,self.alpha,self.delta]\n",
    "    \n",
    "    def set_genes(self,genes):\n",
    "        self.phi = genes[0]\n",
    "        self.alpha = genes[1]\n",
    "        self.delta = genes[2]\n",
    "        \n",
    "    def to_bits(self):\n",
    "        genes = self.get_genes()\n",
    "        split_genes = []\n",
    "        for i in genes:\n",
    "            bin_str = format(i, '#010b')\n",
    "            bin_str = bin_str[2:]\n",
    "            split_genes.append([bin_str[:4],bin_str[4:]])\n",
    "        return split_genes\n",
    "    \n",
    "    def reproduce(self,other):\n",
    "        son1 = pacman()\n",
    "        son2 = pacman()\n",
    "        son1_genes = []\n",
    "        son2_genes = []\n",
    "        mybits = self.to_bits()\n",
    "        otherbits = other.to_bits()\n",
    "        for i,v in enumerate(mybits):\n",
    "            son1_gene = v[0]+otherbits[i][1]\n",
    "            son2_gene = otherbits[i][0]+v[1]\n",
    "            son1_gene = int('0b'+son1_gene,base=2)\n",
    "            son2_gene = int('0b'+son2_gene,base=2)\n",
    "            son1_genes.append(son1_gene)\n",
    "            son2_genes.append(son2_gene)\n",
    "        son1.set_genes(son1_genes)\n",
    "        son2.set_genes(son2_genes)\n",
    "        return [son1,son2]\n",
    "        \n",
    "        \n",
    "p = pacman()\n",
    "p2 = pacman()\n",
    "print(p.reproduce(p2))"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": []
  },
  {
   "cell_type": "code",
   "execution_count": 4,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": [
    "class dot:\n",
    "    def __init__(self):\n",
    "        self.x = random.uniform(0, board_size)\n",
    "        self.y = random.uniform(0, board_size)\n",
    "    def __repr__(self):\n",
    "        return \"{dot, x:\"+str(self.x)+\", y:\"+str(self.y)+\"}\""
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 5,
   "metadata": {
    "collapsed": false
   },
   "outputs": [],
   "source": [
    "def gen1():\n",
    "    global pacmen\n",
    "    pacmen = []\n",
    "    for i in range(0,pacman_amount):\n",
    "        p = pacman()\n",
    "        pacmen.append(p)\n",
    "    pacmen = np.array(pacmen)\n",
    "    print(pacmen[0])\n",
    "    return pacmen\n",
    "\n",
    "def food1():\n",
    "    global food\n",
    "    food = []\n",
    "    for i in range(0,food_amount):\n",
    "        f = dot()\n",
    "        food.append(f)\n",
    "    food = np.array(food)\n",
    "    return food"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 6,
   "metadata": {
    "collapsed": false
   },
   "outputs": [],
   "source": [
    "def driver(gen,life_span,generations):\n",
    "    food = food1()\n",
    "    dt = 1\n",
    "    t = [0]\n",
    "    tracker = []\n",
    "    global pacmen\n",
    "        \n",
    "    for g in range(0,generations): #iterates through each generation\n",
    "        tracker.append([])\n",
    "        for i in range(0,len(pacmen)):\n",
    "            tracker[g].append([])\n",
    "        t.append(t[-1]+dt)\n",
    "        for q in range(0,life_span): #runs through time with current generation\n",
    "            for i,v in enumerate(pacmen):\n",
    "                tracker[g][i].append([v.x,v.y,v.theta])\n",
    "                v.step()\n",
    "        \n",
    "        \n",
    "        #makes the next generation\n",
    "        sons = []\n",
    "        healthy_pacmen = []\n",
    "        for i,v in enumerate(pacmen): #end of a generation mean reproduce\n",
    "                if(v.health > 0):\n",
    "                    healthy_pacmen.append(v)\n",
    "        \n",
    "        for i,v in enumerate(healthy_pacmen):\n",
    "            if( i % 2 == 1):\n",
    "                temp = v.reproduce(healthy_pacmen[i-1])\n",
    "                sons.extend(temp)\n",
    "                \n",
    "        #print('generation over')\n",
    "        pacmen = sons\n",
    "    return t,tracker"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 9,
   "metadata": {
    "collapsed": false
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "{pacman, x:67, y:77, phi:52}\n",
      "263.5206654046971\n",
      "280.90858284436945\n",
      "289.3060238383546\n",
      "312.58911836807846\n",
      "318.2527553136118\n",
      "357.59514264881625\n",
      "231.35988590048692\n",
      "190.56070476453618\n",
      "239.54516887866865\n",
      "262.2616401859034\n",
      "216.8928508215002\n",
      "256.6469532539659\n",
      "193.3660130014478\n",
      "365.5313742190705\n",
      "194.6486339429472\n",
      "217.30004675424482\n",
      "211.63534195247934\n",
      "361.9547070477688\n",
      "214.01428330165984\n",
      "216.15385559839225\n",
      "344.95091764643075\n",
      "366.4132067446574\n",
      "345.116386932689\n",
      "316.7710592544355\n",
      "264.3461994582524\n",
      "223.3033829633468\n",
      "226.58295610986514\n",
      "319.4434441299796\n",
      "213.68655639652883\n",
      "187.89796729366674\n",
      "276.0546321730351\n",
      "249.9774657754155\n",
      "227.7628736564204\n",
      "363.87603056380107\n",
      "191.02775957234925\n",
      "252.38192422629947\n",
      "345.7424466526589\n",
      "189.5200494315498\n",
      "254.31958705513284\n",
      "206.42781962516605\n",
      "317.1173237398926\n",
      "244.5725232222342\n",
      "204.9130362276265\n",
      "311.281630855251\n",
      "220.22523980843175\n",
      "235.00767008839676\n",
      "338.4154956705046\n",
      "296.3382940675976\n",
      "397.9422421075771\n",
      "7.68378126140378\n",
      "6.909672635589189\n",
      "7.696185140659253\n",
      "8.495919048943009\n",
      "178.42929009179153\n",
      "180.78457747421777\n",
      "178.45924287412151\n",
      "176.7789727666705\n",
      "175.38950453552425\n",
      "181.99720861194533\n",
      "176.1179583862816\n",
      "8.796580600487943\n",
      "4.846636151983176\n",
      "4.187456474995031\n",
      "4.287462459406257\n",
      "176.9639526792213\n",
      "4.413456105625045\n",
      "181.00471160802482\n",
      "178.02413712507058\n",
      "182.7179634927157\n",
      "176.4092879503591\n",
      "9.871581508218085\n",
      "175.66422091012714\n",
      "6.969100945877301\n",
      "179.1251639841193\n",
      "5.595356082438684\n",
      "7.279672336191084\n",
      "4.999741206850572\n",
      "180.67734360941512\n",
      "3.6962523093835813\n",
      "8.384478323559875\n",
      "179.98510213204318\n",
      "177.96003105941242\n",
      "9.694257409054558\n",
      "182.23849966248434\n",
      "182.02980697748197\n",
      "5.341566418411759\n",
      "177.40886846405238\n",
      "182.86244181992907\n",
      "5.712562862984157\n",
      "180.72253183118124\n",
      "11.588623627879485\n",
      "176.71040279835748\n",
      "175.65729353400002\n",
      "181.20691785788893\n",
      "5.120199801520073\n",
      "9.551807563238285\n",
      "173.5553700237802\n",
      "179.25256265913174\n",
      "8.677637062097702\n",
      "8.677637062097702\n",
      "267.3096941146285\n",
      "2.112030004962257\n",
      "2.5181164298851826\n",
      "1.7588162046214748\n",
      "4.349850223504902\n",
      "-7.905714594942339\n",
      "-2.7361080846840906\n",
      "-1.7435609983201061\n",
      "-2.5806844353612917\n",
      "-5.810952933843154\n",
      "-7.521256308073291\n",
      "-6.780146844523088\n",
      "-6.68506684907328\n",
      "5.167544948174587\n",
      "-5.701995940949715\n",
      "-0.25659233825683714\n",
      "0.37030733789966064\n",
      "2.0974864314248123\n",
      "-3.9567576171094885\n",
      "-4.208786655158093\n",
      "-1.917604498258882\n",
      "-4.691952533730031\n",
      "-3.3942656613548507\n",
      "-4.753223161922975\n",
      "-3.902365689031484\n",
      "-8.705975764767928\n",
      "-10.43172608392041\n",
      "4.266480360771297\n",
      "-2.1558011354894404\n",
      "1.8712840318181918\n",
      "-2.3024965271885094\n",
      "-2.074566436571544\n",
      "-1.828357407486891\n",
      "1.0832421974219386\n",
      "3.4025585218710646\n",
      "-4.248245081022915\n",
      "-4.4980958021725\n",
      "6.118583263254756\n",
      "-1.7405068878557302\n",
      "-2.3614680395361063\n",
      "-6.8119287850364\n",
      "1.9958969929302341\n",
      "-3.86252879258231\n",
      "-1.725790893217578\n",
      "2.5038697517415685\n",
      "-5.209932855299471\n",
      "7.927808704622336\n",
      "-6.024968672822823\n",
      "-6.316307693166692\n",
      "-5.425070208699012\n",
      "2.706855254950618\n",
      "5.013522879197282\n",
      "-7.719384943309521\n",
      "-3.0244977456343065\n",
      "5.006743622338966\n",
      "293.83983515525904\n",
      "244.46459611543062\n",
      "244.06534831990956\n",
      "244.3531989253231\n",
      "245.80172507788978\n",
      "236.2963900460981\n",
      "238.31232507753268\n",
      "236.36887900628682\n",
      "234.11441907165516\n",
      "235.42383357838258\n",
      "412.7972363037621\n",
      "233.35904585570438\n",
      "246.29828449358712\n",
      "233.70823366040094\n",
      "241.68292836468095\n",
      "241.429156172189\n",
      "242.0888560876434\n",
      "234.758493967755\n",
      "240.83049685895085\n",
      "237.51533608782916\n",
      "235.78952406300758\n",
      "238.98871832264894\n",
      "412.9481744394041\n",
      "411.88259954699663\n",
      "244.71690765929753\n",
      "236.9878418241995\n",
      "244.10151686639725\n",
      "241.19311517098697\n",
      "238.20777866581977\n",
      "241.32509310363957\n",
      "245.3939937281374\n",
      "236.92630817564162\n",
      "235.3876577294929\n",
      "247.25499019891026\n",
      "239.3485325982939\n",
      "238.99674802069245\n",
      "242.79201364373608\n",
      "235.1927663204391\n",
      "239.7960905065447\n",
      "243.2263735461818\n",
      "237.14930665353398\n",
      "249.20438258965277\n",
      "233.99721702198104\n",
      "233.13796029702291\n",
      "237.42821018897726\n",
      "242.88319131609848\n",
      "246.762864669794\n",
      "411.1584387301356\n",
      "236.7950337960478\n",
      "246.1592254574685\n",
      "206.29089676862975\n",
      "108.00851040867664\n",
      "109.02418790145623\n",
      "107.52022034853019\n",
      "110.46216217956012\n",
      "102.37692179356333\n",
      "107.48939315064226\n",
      "107.26044481997084\n",
      "107.66809973339834\n",
      "104.55350268798841\n",
      "100.12764780766007\n",
      "104.2363425495902\n",
      "103.83390855517808\n",
      "105.12970371787726\n",
      "99.11956007449945\n",
      "102.35286397196447\n",
      "107.87518003932418\n",
      "110.02908520753412\n",
      "106.32249257604869\n",
      "106.55356176144144\n",
      "103.04533484715704\n",
      "106.90678452892476\n",
      "103.78340289816867\n",
      "102.92329265318153\n",
      "100.70616862741058\n",
      "99.55266931310156\n",
      "98.69951275423912\n",
      "111.21142403912455\n",
      "102.24180812338076\n",
      "107.78613531298137\n",
      "107.93715124336109\n",
      "103.40915669015526\n",
      "103.93049249952996\n",
      "107.21866657662599\n",
      "109.09892544581902\n",
      "109.29996804199146\n",
      "105.99579319330445\n",
      "104.41998759120776\n",
      "105.49746505597166\n",
      "98.64501980005815\n",
      "103.03825531374227\n",
      "105.60840529577817\n",
      "102.7853068903132\n",
      "106.70637707926085\n",
      "105.91704252406703\n",
      "109.71512168579345\n",
      "102.50064016630664\n",
      "113.25119417598842\n",
      "101.56007958663318\n",
      "104.31042146997302\n",
      "104.671485231496\n",
      "101.81036162630646\n",
      "110.31178249790098\n",
      "110.71085241480849\n",
      "104.30526104842662\n",
      "106.58056270217205\n",
      "111.19099983602533\n",
      "283.3962491414901\n",
      "169.3559039248456\n",
      "170.23832491948775\n",
      "171.00267973377893\n",
      "167.66607069692702\n",
      "170.06512457999202\n",
      "170.73231225982886\n",
      "168.96088374722802\n",
      "165.1661756795081\n",
      "169.01661572253303\n",
      "168.60148028234434\n",
      "169.46261484546875\n",
      "164.90905402547887\n",
      "166.94664566994007\n",
      "171.36863509759087\n",
      "169.9589763621837\n",
      "170.25808000955024\n",
      "166.7460114054073\n",
      "167.0047751816502\n",
      "170.30656019372137\n",
      "167.79348920171304\n",
      "166.52208897851597\n",
      "166.3241170383219\n",
      "164.87169618041094\n",
      "165.00954437876115\n",
      "167.56270680056588\n",
      "169.3781179934983\n",
      "166.31393433309353\n",
      "166.78665509639984\n",
      "170.05539774632902\n",
      "166.4059111198157\n",
      "170.18257134863484\n",
      "168.54522429927147\n",
      "168.23135468361085\n",
      "169.37657688983342\n",
      "164.8477259454212\n",
      "167.54556219606098\n",
      "168.676888300497\n",
      "167.62940612285288\n",
      "170.28100344242867\n",
      "168.73724105457987\n",
      "166.6572857088492\n",
      "167.21447301254074\n",
      "169.25529148078306\n",
      "166.01354767393693\n",
      "171.4315970005624\n",
      "171.00954955794202\n",
      "166.3655808628637\n",
      "169.4135446393984\n",
      "169.87391987400156\n",
      "171.48990740749144\n",
      "317.70666893650616\n",
      "129.58424218552406\n",
      "130.10298894088677\n",
      "128.44322463348158\n",
      "130.46056027405302\n",
      "129.21193829332483\n",
      "130.24888860720685\n",
      "130.681083401133\n",
      "127.67920872583802\n",
      "129.83560897889882\n",
      "127.6972312791123\n",
      "129.92204907031967\n",
      "129.67879578844213\n",
      "130.11755486377356\n",
      "127.67816204511142\n",
      "128.6789384975064\n",
      "128.86118705792703\n",
      "130.80881538213507\n",
      "130.3082111346116\n",
      "130.4929235216701\n",
      "128.38701163644376\n",
      "128.60671938862885\n",
      "130.47839901400093\n",
      "129.0859947688678\n",
      "128.252570638689\n",
      "128.48027939894988\n",
      "127.5724473902107\n",
      "127.82679030895356\n",
      "129.15658494060543\n",
      "127.64174763257228\n",
      "129.61410678164208\n",
      "127.99694086519933\n",
      "128.27774141861042\n",
      "130.2479128208617\n",
      "129.2965000905727\n",
      "128.40746078195338\n",
      "130.0132858902402\n",
      "129.29521699055104\n",
      "129.31432918775224\n",
      "130.00156346358224\n",
      "127.7138785483245\n",
      "129.01926667879763\n",
      "129.46075044738328\n",
      "129.12193054010905\n",
      "130.48812134502134\n",
      "129.45646277902756\n",
      "128.43253525129865\n",
      "129.00507741084655\n",
      "130.03264051896718\n",
      "128.0891854265348\n",
      "130.19711975571514\n",
      "130.20825605668708\n",
      "130.72043207309085\n",
      "338.1655639983099\n",
      "250.82389327106227\n",
      "251.8479987590134\n",
      "250.33586866173619\n",
      "253.26138939906858\n",
      "245.38065410405224\n",
      "250.43374701841216\n",
      "250.17307389154288\n",
      "250.61101644840534\n",
      "247.5354763334592\n",
      "243.06839574581528\n",
      "247.24130110741555\n",
      "246.82863808898531\n",
      "248.11878117575867\n",
      "242.09479924062435\n",
      "245.30315377705566\n",
      "250.73863907676446\n",
      "252.88253284132742\n",
      "249.28183854240106\n",
      "249.5238937258965\n",
      "245.96218392780793\n",
      "249.86000763151165\n",
      "246.71817978297724\n",
      "245.8120574037125\n",
      "243.69983423274684\n",
      "242.50273628240612\n",
      "241.70395147532506\n",
      "254.02611257043174\n",
      "245.24507637718006\n",
      "250.71921118165616\n",
      "250.7581628955928\n",
      "246.2577422492473\n",
      "246.78425012780554\n",
      "250.13296849245899\n",
      "251.9643960993466\n",
      "252.103831222186\n",
      "248.8636474711213\n",
      "247.35240131517315\n",
      "248.4579767473503\n",
      "241.64068996055687\n",
      "245.99570566893718\n",
      "248.5078386422111\n",
      "245.76326836714995\n",
      "249.66946516891034\n",
      "248.80366396490186\n",
      "252.55205683088457\n",
      "245.42171622754466\n",
      "256.00285810257645\n",
      "244.57445266786425\n",
      "247.29427103155422\n",
      "247.67049471279796\n",
      "244.72229144103474\n",
      "253.15343688597247\n",
      "253.4962209700238\n",
      "247.33906211585884\n",
      "249.5177491104402\n",
      "253.9853065942064\n",
      "282.9082307295594\n",
      "225.9122452658114\n",
      "226.94538930635903\n",
      "228.05607043217472\n",
      "222.48371502220604\n",
      "226.6511507441401\n",
      "226.144334074016\n",
      "226.8029318298734\n",
      "224.28930981851698\n",
      "219.7727999968002\n",
      "224.21207314204494\n",
      "223.74471295648084\n",
      "224.88762382534614\n",
      "219.17908735225205\n",
      "221.94387913518733\n",
      "228.16287146418253\n",
      "225.7121079494645\n",
      "226.02694834919046\n",
      "222.26083493458515\n",
      "226.19499759477057\n",
      "223.12432906142558\n",
      "221.8677071019119\n",
      "220.83816073246555\n",
      "219.32946592999332\n",
      "219.0807241808801\n",
      "222.3543031937305\n",
      "226.82134663185846\n",
      "225.90014501589397\n",
      "221.91966103118833\n",
      "222.4621603155753\n",
      "226.1212692045977\n",
      "227.01179350851265\n",
      "224.53810627620697\n",
      "223.69377707528037\n",
      "224.96038393922055\n",
      "218.94228223572247\n",
      "222.65114170119023\n",
      "224.48244629117113\n",
      "222.6144748375979\n",
      "226.10111201717203\n",
      "224.64662427693878\n",
      "227.7156481546669\n",
      "221.79386012013848\n",
      "221.83044573202562\n",
      "224.08235036520603\n",
      "224.557646774415\n",
      "221.05720047152286\n",
      "228.31592514186477\n",
      "228.15665466718337\n",
      "224.5431071996659\n",
      "225.74423441786342\n",
      "228.69128159536726\n",
      "302.0216587872447\n",
      "12.787506597341903\n",
      "191.80408177195892\n",
      "12.872414911576328\n",
      "13.278546266638969\n",
      "183.04797539365165\n",
      "185.55535024538872\n",
      "183.05394540415077\n",
      "181.71467173842026\n",
      "180.30564350304212\n",
      "187.5424047927781\n",
      "181.11428560540799\n",
      "13.458151662185955\n",
      "189.9544951711535\n",
      "189.0708270591797\n",
      "188.84699146260243\n",
      "181.64606666237165\n",
      "13.702420650005521\n",
      "189.76764738454466\n",
      "186.34413793780334\n",
      "182.7054200757453\n",
      "188.17413610236758\n",
      "181.7848004557141\n",
      "15.151008670034813\n",
      "181.2225093212794\n",
      "191.51503325903866\n",
      "183.73495239945768\n",
      "191.12402863798096\n",
      "12.364565870936389\n",
      "190.47609522624433\n",
      "185.44822680658012\n",
      "188.3646392258593\n",
      "12.39507919289845\n",
      "13.344108211290134\n",
      "185.0955405070403\n",
      "182.82828310915068\n",
      "14.305987353327325\n",
      "187.22421467577428\n",
      "187.09937749624294\n",
      "190.08730910826552\n",
      "182.0897395072857\n",
      "14.852982815695228\n",
      "187.9400850881105\n",
      "190.415755963882\n",
      "186.1121962039411\n",
      "16.135345833573908\n",
      "181.67362491783928\n",
      "180.53007857319835\n",
      "186.70686253096162\n",
      "189.68811693902109\n",
      "14.374942664072748\n",
      "178.39346456154578\n",
      "184.03819504617883\n",
      "13.35307488632563\n",
      "13.35307488632563\n",
      "257.2097806737936\n"
     ]
    }
   ],
   "source": [
    "t,tracker = driver(gen1(),10,1)\n",
    "#print(tracker[0][0])"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": []
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": []
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": []
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": []
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Anaconda (Python 3)",
   "language": "python",
   "name": "anaconda3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.5.2"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 0
}
